/*
 * Copyright(c) 1995-1998 by Gennady B. Sorokopud (gena@NetVision.net.il)
 *
 * This software can be freely redistributed and modified for
 * non-commercial purposes as long as above copyright
 * message and this permission notice appear in all
 * copies of distributed source code and included as separate file
 * in binary distribution.
 *
 * Any commercial use of this software requires author's permission.
 *
 * This software is provided "as is" without expressed or implied
 * warranty of any kind.
 * Under no circumstances is the author responsible for the proper
 * functioning of this software, nor does the author assume any
 * responsibility for damages incurred with its use.
 *
 */

/* $Id: imap_conf.c,v 1.3 1999/11/07 22:27:57 xfmail Exp $
 */

#include <config.h>
#include <fmail.h>
#include <umail.h>
#include <choose_folder.h>
#include "configform.h"

extern FD_POPacc *pacc_obj;
static FD_acc_imap *imap_acc_obj;
static int ready = 0;

void IMAP_Host_Call(FL_OBJECT * obj, long param) {
}

void IMAP_Port_Call(FL_OBJECT * obj, long param) {
}

void IMAP_User_Call(FL_OBJECT * obj, long param) {
}

void IMAP_Pwd_Call(FL_OBJECT * obj, long param) {
}

void IMAP_Use_Trash_Call(FL_OBJECT * obj, long param) {
}

void IMAP_Store_Pwd_Call(FL_OBJECT * obj, long param) {
    if(fl_get_button(imap_acc_obj->IMAP_Store_Pwd))
        fl_show_alert("WARNING", "This is very unsecure option",
                      "make sure your config file (.xfmsources) is not readable by anyone else",
                      1);

}

void IMAP_Extra_Call(FL_OBJECT * obj, long param) {
}

void IMAP_Autocon_Call(FL_OBJECT * obj, long param) {
}

void imap_account(struct _imap_src *imap) {
    char title[64];

    if(ready)
        return;

    ready = 1;

    snprintf(title, sizeof(title), "Login to '%s' on", imap->source->name);

    fl_set_input(pacc_obj->P_Username, imap->username);
    fl_set_input(pacc_obj->P_Password, imap->password);
    fl_set_object_label(pacc_obj->P_Server, imap->hostname);
    fl_set_object_label(pacc_obj->P_Title, title);

    fl_set_object_focus(pacc_obj->POPacc, pacc_obj->P_Password);

    fl_show_form(pacc_obj->POPacc, FL_PLACE_CENTER, FL_TRANSIENT,
                 "IMAP login");

    fl_do_only_forms();

    strncpy(imap->username, (char *) fl_get_input(pacc_obj->P_Username),
            31);
    imap->username[31] = '\0';
    strncpy(imap->password, (char *) fl_get_input(pacc_obj->P_Password),
            31);
    imap->password[31] = '\0';

    fl_hide_form(pacc_obj->POPacc);

    ready = 0;
    return;
}

void imap_acc(struct _retrieve_src *source) {
    struct _imap_src *imap;

    imap = (struct _imap_src *) source->spec;
    if(ready)
        return;
    ready = 1;
    imap_acc_obj = create_form_acc_imap();

    fl_set_input(imap_acc_obj->IMAP_Host, imap->hostname);
    fl_set_input(imap_acc_obj->IMAP_Port, imap->service);
    fl_set_input(imap_acc_obj->IMAP_User, imap->username);
    fl_set_input(imap_acc_obj->IMAP_Pwd, imap->password);
    fl_set_input(imap_acc_obj->IMAP_Extra, imap->list);

    fl_set_button(imap_acc_obj->IMAP_Autocon,
                  (imap->flags & ISRC_AUTOCON) ? 1 : 0);
    fl_set_button(imap_acc_obj->IMAP_Store_Pwd,
                  (imap->flags & ISRC_STOREPWD) ? 1 : 0);
    fl_set_button(imap_acc_obj->IMAP_Log,
                  (imap->flags & ISRC_LOGSESSION) ? 1 : 0);
    fl_set_button(imap_acc_obj->IMAP_Use_Trash,
                  (imap->flags & ISRC_TRASH) ? 1 : 0);
    fl_set_button(imap_acc_obj->IMAP_Cache,
                  (imap->flags & ISRC_CACHE) ? 1 : 0);
    fl_set_button(imap_acc_obj->IMAP_NExpunge,
                  (imap->flags & ISRC_NOEXPUNGE) ? 1 : 0);
    fl_set_button(imap_acc_obj->IMAP_Retrieve,
                  (imap->flags & ISRC_RETRIEVE) ? 1 : 0);

    fl_show_form(imap_acc_obj->acc_imap, FL_PLACE_CENTER, FL_TRANSIENT,
                 "IMAP server");
    fl_do_only_forms();

    strncpy(imap->hostname, fl_get_input(imap_acc_obj->IMAP_Host),
            MAX_HOST - 1);
    imap->hostname[MAX_HOST - 1] = '\0';
    strncpy(imap->service, fl_get_input(imap_acc_obj->IMAP_Port), 15);
    imap->service[15] = '\0';
    strncpy(imap->username, fl_get_input(imap_acc_obj->IMAP_User), 31);
    imap->username[31] = '\0';
    strncpy(imap->password, fl_get_input(imap_acc_obj->IMAP_Pwd), 31);
    imap->password[31] = '\0';
    strncpy(imap->list, fl_get_input(imap_acc_obj->IMAP_Extra), 127);
    imap->list[127] = '\0';

    imap->flags = 0;
    if(fl_get_button(imap_acc_obj->IMAP_Autocon))
        imap->flags |= ISRC_AUTOCON;
    if(fl_get_button(imap_acc_obj->IMAP_Store_Pwd))
        imap->flags |= ISRC_STOREPWD;
    if(fl_get_button(imap_acc_obj->IMAP_Log))
        imap->flags |= ISRC_LOGSESSION;
    if(fl_get_button(imap_acc_obj->IMAP_Use_Trash))
        imap->flags |= ISRC_TRASH;
    if(fl_get_button(imap_acc_obj->IMAP_Cache))
        imap->flags |= ISRC_CACHE;
    if(fl_get_button(imap_acc_obj->IMAP_NExpunge))
        imap->flags |= ISRC_NOEXPUNGE;
    if(fl_get_button(imap_acc_obj->IMAP_Retrieve))
        imap->flags |= ISRC_RETRIEVE;

    fl_hide_form(imap_acc_obj->acc_imap);
    fl_free_form(imap_acc_obj->acc_imap);
    fl_free(imap_acc_obj);
    imap_acc_obj = NULL;

    ready = 0;
    return;
}
